//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  Silver
#property indicator_color4  DeepSkyBlue
#property indicator_color5  DeepSkyBlue
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_level1  0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int CorrPeriod  = 100;
extern int CorrMaxLag  =  10;
extern int CorrPrice   =  PRICE_CLOSE;
extern int CorrAverage =   1;

//
//
//
//
//

double corr[];
double corrUa[];
double corrUb[];
double corrDa[];
double corrDb[];
double levu[];
double levd[];
double significantLevel;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(8);
      SetIndexBuffer(0,levu); SetIndexLabel(0,NULL);
      SetIndexBuffer(1,levd); SetIndexLabel(1,NULL);
      SetIndexBuffer(2,corr);
      SetIndexBuffer(3,corrUa);
      SetIndexBuffer(4,corrUb);
      SetIndexBuffer(5,corrDa);
      SetIndexBuffer(6,corrDb);
      
      //
      //
      //
      //
      //

      significantLevel = 2.0/MathSqrt(CorrPeriod);
   IndicatorShortName("Autocorrelation max ("+CorrPeriod+","+CorrMaxLag+")");
   return(0); 
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double diff[];
double work[][3];
#define _values 0
#define _trendu 1
#define _trendd 2

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars)
         {
            ArrayResize(work,Bars);
            ArrayResize(diff,Bars);
         }

   //
   //
   //
   //
   //

   if (work[Bars-limit-1][_trendd]==-1) CleanPoint(limit,corrDa,corrDb);
   if (work[Bars-limit-1][_trendu]== 1) CleanPoint(limit,corrUa,corrUb);
   for(i=limit,r=Bars-i-1; i>=0; i--,r++)
   {
      levu[i]          = +significantLevel;
      levd[i]          = -significantLevel;
      work[r][_values] = iMA(NULL,0,CorrAverage,0,MODE_SMA,CorrPrice,i);
               diff[r] = work[r][_values]-work[r-1][_values];
  
      //
      //
      //
      //
      //
         
      double avgi      = diff[r]; for (int k=1; k<CorrPeriod; k++) avgi += diff[r-k]; avgi /= CorrPeriod;
      double variance  = 0;
         for (k=0; k<CorrPeriod; k++) variance += (diff[r-k]-avgi)*(diff[r-k]-avgi); variance /= CorrPeriod;
   
         //
         //
         //
         //
         //
               
         if (variance != 0)
         {
            double max  = 0;
            double avgd = avgi+(diff[r-CorrPeriod]-diff[r])/CorrPeriod;
            for (k=1; k<=CorrMaxLag; k++)
            {
               double covariance = 0; for (int j=0; j<CorrPeriod; j++) covariance += (diff[r-j]-avgi)*(diff[r-j-k]-avgd);
               double current = (covariance/CorrPeriod)/variance;
                     if (MathAbs(current)>max)
                     {
                        corr[i] = current; max = MathAbs(current);
                     }
               avgd += (diff[r-k-CorrPeriod]-diff[r-k])/CorrPeriod;
            }
         }
         else corr[i] = 0;

         //
         //
         //
         //
         //
         
         corrUa[i] = EMPTY_VALUE;
         corrUb[i] = EMPTY_VALUE;
         corrDa[i] = EMPTY_VALUE;
         corrDb[i] = EMPTY_VALUE;
         work[r][_trendu] = work[r-1][_trendu];
         work[r][_trendd] = work[r-1][_trendd];
            if (corr[i]> significantLevel) work[r][_trendu] =  1;
            if (corr[i]< significantLevel) work[r][_trendu] = -1;
            if (corr[i]<-significantLevel) work[r][_trendd] = -1;
            if (corr[i]>-significantLevel) work[r][_trendd] =  1;
            if (work[r][_trendu]== 1) PlotPoint(i,corrUa,corrUb,corr);
            if (work[r][_trendd]==-1) PlotPoint(i,corrDa,corrDb,corr);

   }
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}